outlets = 2;

var subdiv = 8.;
declareattribute("subdiv",null,null);

var len = 4;

var maxprob = 1.;
//declareattribute("maxprob",null,null);
var midprob = .5;
//declareattribute("midprob",null,null);
var minprob = .25;
//declareattribute("minprob",null,null);
var noprob = 0.;

var floor = 0.;
var offset_ = 0.;

var listActive = 0;

var problist = new Array();
var longlist = new Array();
 
function setmaxprob(v) 
{ 
	maxprob = v; 
} 

function setmidprob(v) 
{ 
	midprob = v; 
} 

function setminprob(v) 
{ 
	minprob = v; 
} 

function setnoprob(v) 
{ 
	noprob = v; 
} 

function setfloor(v) 
{ 
	floor = v; 
} 

function update() {
	make(len);	
}

function fromlist(v)
{
	listActive = 1;
	outlet(0,"clear");
	//post("len, subdiv: ",len,subdiv,"\n");
	problist = new Array();
	for (var k=0;k<len*subdiv;k++) {
		problist[k] = v[Math.round(k/len/subdiv*v.length)];
	}
	
	outputprobs(problist);
}


function setlist(v)
{

	longlist = new Array();
	longlist = arrayfromargs(arguments);
	//post("long list len: ", longlist.length);
	//post();
	
	fromlist(longlist);
}

function getlonglist()
{	
	outlet(1,longlist);
}

function rotate(offset)
{
	offset_ = offset;
	outputprobs(problist);

}

function outputprobs(v)
{
		outlet(0,"clear");
		v = rotatelist( v ,offset_);
		for (var k=0;k<len*subdiv;k++) {
			var outlist = [k/subdiv/len,scale(v[k], 0., 1., floor, 1.)];
			outlet(0,outlist);
		}
		outlet(0,[1.,scale(v[0], 0., 1., floor, 1.)]);
}

function rotatelist(v,offsetN)
{
	offset = offsetN * v.length;
	var a = new Array();
	var b = new Array();
	var c = new Array();
	for (var k = 0;k<v.length;k++) {
			a[k] = v[k]; }
	b = a.splice(offset);
	c = c.concat(b,a);
	return(c);
}

function make(i) {
	listActive = 0;
	len = i;
	outlet(0,"clear");
	problist = new Array();
	for (var k=0;k<len*subdiv;k++) {
		//var mod = Math.abs((k % 4 - 1) % 2);
		//var mod = Math.abs(((k % 4) > 0) * ((k % 4) % 2));
		var prob = noprob;
		//post("k: ",k,"\n");
		//var thismod = k % 8;
		switch (k%8) {
			case 0: prob = maxprob; break;
			case 2: prob = minprob; break;
			case 4: prob = midprob; break;
			case 6: prob = minprob; break;
		}
		problist[k] = prob;
		
	}
	
	outputprobs(problist);
	

}


//----------------math
function scale(x,inmin, inmax,outmin,outmax)
{
	var xout = (x-inmin)/(inmax-inmin)*(outmax-outmin)+outmin;
	// post("here's the scaled: ", xout, "\n");
	return xout;
}